# 2022-09-07 - 🚀 It works!

## 🏃‍♂️ Reculer pour mieux sauter

Dans Fastify, il n'est (toujours) pas possible d'ajouter des routes ou des plugins à la volée (cf. [issue #149](https://github.com/fastify/help/issues/149)).

Dans mon cas, ce n'est pas si grave. 
Si une app se fait proxifiée une fois, si jamais elle doit être réveillée, au moins le routage sera prêt.

Mais il me vient une réflexion : si on ne peut pas proxifier des routes/apps à la volée, comment manager de nouvelles apps, pas présentes au démarrage ?

Pistes :
- Peut-être que `@fastify/http-proxy`, de par son comportement basé sur les prefix de requêtes, permet de le faire
- Peut-être que je vais vraiment devoir faire le proxy à la main (et bye-bye la semi-gestion des WebSockets)

Mais du coup, quite à faire un simple proxy_pass, pourquoi s'embêter avec Nginx 🤔

> ⚠️ Quid des requêtes de fichier / multipart / stream ?

Et si le plus simple était de passer directement par [`fastify-reply-from`](https://github.com/fastify/fastify-reply-from) ? 
Comme ça plus de besoin de Nginx.
Et je récupère directement le app_name (via tldts).
Testons.

## 🔮 L'Oracle

Call avec JOP
https://publicsuffix.org/
proposer à Scalingo de faire comme Heroku et proposer un Public Suffix
pour tous les hébergeurs qui revendent des sous-domaines, permet de protéger 2 sites hébergés qui n'ont rien à voir

J'ai zappé le cas où une RA est créée (90% des cas).
Et tant que je n'essaye pas d'y accéder, elle ne sera pas managée.
Mais du coup, mon truc ne sert à rien en l'état.
Il me faut absolument poller l'API de Scalingo régulièrement.
Toutes les minutes.

## 👋 Bye-bye Fastify, hello `node-http-proxy`

Mettre un Nginx en frontal d'un serveur Fastify, via le plugin `@fastify/http-proxy` est à la fois overkill (2 composants indépendants dans un langage différent) et contraignant (le fait de ne pouvoir ajouter des routes à la volée).
Utiliser `@fastify/reply-from`, la lib sous-jacente à `@fastify/http-proxy` complexifie encore plus la chose.
Sachant que dans le tout, on n'a pas un support complet des Web Sockets.
Même si dans les faits, je ne pense pas que tant de projets utilisent les ws.
Finalement, le fait de passer par un serveur Web un "haut niveau" (tout est relatif) est un frein plus qu'une aide.

Jonathan me propose d'utiliser le module Node natif `http` et la lib `node-http-proxy`, en particulier [cet exemple](https://github.com/http-party/node-http-proxy#setup-a-stand-alone-proxy-server-with-custom-server-logic).
L'un des avantages, c'est que cette fois on a toute latitude pour choisir une cible à la volée.
🙌 Avec cette solution, plus besoin de Nginx ni de Fastify !

🎉 Rapidement, on obtient un résultat qui fonctionne. Yeah !!!

Node propose un exemple dans la documentation officielle pour faire un proxy.
Mais on est vraiment très bas niveau, trop.
`node-http-proxy` propose [tout un tas d'options](https://github.com/http-party/node-http-proxy#options) bien pratiques comme `changeOrigin`, `hostRewrite` ou `protocolRewrite`.  

Finalement, pas besoin d'utiliser `tldts` pour parser l'URL.
Un coup de `String.replace()` suffit.
💪 En plus, ça supporte `localhost:port`. 

> 💡 Pour tester en local, sans avoir à s'embêter avec le `/etc/hosts`, il suffit de préciser le header `Host` avec cURL :
> ```
> $ curl -v http://localhost:3000 -H Host:hello-fastify.gateway.paastis.io
> ```

```shell
$ scalingo -a hello-fastify scale web:0 && sleep 2 ; curl -v http://localhost:3000 -H Host:hello-fastify.gateway.paastis.io
```

## 📖 Registre des applications actives

Maintenant que c'est ok pour le proxy (note : renommer "gateway" en proxy") je peux passer à la gestion des apps Scalingo à proprement parler.

Dans les grandes lignes, il s'agit surtout d'une simple map `Map<appName:String, appData:ManagedApp>`.
